#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <stdio.h>
Fl_Menu_Item *G_item = 0;
void menu_cb(Fl_Widget* w, void* userdata) {
  Fl_Menu_* mw = (Fl_Menu_*)w;
  const Fl_Menu_Item* item = mw->mvalue();
  char ip[200];
  mw->item_pathname(ip, sizeof(ip)-1);
  const Fl_Menu_Item *item_red = mw->find_item("Red");
  const Fl_Menu_Item *item_one = mw->find_item("Submenu/One");
  printf("--- MENU CALLBACK:\n");
  printf("    value() = %d\n", mw->value());
  printf("            item = %p\n", item);
  printf("    item first() = %p\n", item->first());
  printf("     item next(0)= %p\n", item->next(0));
  printf("     item next(1)= %p\n", item->next(1));
  printf("      item path()= '%s'\n", ip);
  printf("      find_item(\"Red\")= '%p'\n", item_red);
  printf("      find_item(\"Submenu/One\")= '%p'\n", item_one);
}
int main() {
  static Fl_Menu_Item submenu_table[] = {
    {"One",   0, menu_cb, (void *)0x201, FL_MENU_RADIO},	// picking this calls setonly() on one of the colors
    {"Two",   0, menu_cb, (void *)0x202, FL_MENU_RADIO},
    {0}		// end this submenu
  };
  static Fl_Menu_Item menutable[] = {
    {"File",	0, menu_cb, (void *)0x001, FL_SUBMENU},
     {"Open",	0, menu_cb, (void *)0x002, 0},
     {"Save",	0, menu_cb, (void *)0x003, 0},
     {"Quit",	0, menu_cb, (void *)0x004, 0},
     {0},	// end File submenu
    {"Red",	0, menu_cb, (void *)0x101, FL_MENU_RADIO},	// group of radio items at /very top/ of menu
    {"Orange",	0, menu_cb, (void *)0x102, FL_MENU_RADIO},
    {"Submenu", 0, 0,       &submenu_table, FL_SUBMENU_POINTER},
    {"Help",	0, menu_cb, (void *)0x301, FL_SUBMENU},
     {"About",	0, menu_cb, (void *)0x302, 0},
     {"Website",0, menu_cb, (void *)0x303, 0},
     {0},	// end Help submenu
    {0}		// End menubar
  };
  Fl_Double_Window win(400,200);
  win.begin();
    Fl_Menu_Bar menubar(0,0,win.w(),30);
    menubar.menu(menutable);
  G_item = (Fl_Menu_Item*)menubar.find_item("Red");	// the color item that will be setonly() when item 'One' is picked
  win.end();
  win.show();
  return Fl::run();
}

